﻿Imports System.Windows.Forms
Imports System.Text.RegularExpressions

Public Class frmFindInListView

    Private objListview As ListView
    Private objMainForm As Form
    Private bolIngnoreColumnsWithZeroWidth As Boolean

    Private bSearched As Boolean = False 'Wird benötigt umd bei einfach Auswhal festzusellen, das schon mal gesucht wurde
    Private iLastFoundRowIndex As Integer = 0, iLastCheckedRowIndex As Integer
    Private bTextFound As Boolean = False

    Private Sub OK_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OK_Button.Click
        '*** Alle Texte in LisView selektieren, in dem der Text vorkommt ***
        Dim i As Integer, y As Integer, iSearchStart As Integer

        'Wenn bei letzer Suche (Single-Select in ListView) die letzte Zeile erreicht wurde, dann Suche von neu beginnen
        If objListview.MultiSelect = False AndAlso iLastCheckedRowIndex = objListview.Items.Count - 1 Then
            bSearched = False
            iLastFoundRowIndex = 0
            iLastCheckedRowIndex = 0
        End If

        'Startzeile für Suche festlegen (jenachdem ob Liste Multi-Select erlaub oder nicht)
        If objListview.MultiSelect = True Then
            iSearchStart = 0

            'Alle Selektionen bei Multi-Select entfernen
            Dim oListViewItem As ListViewItem
            For Each oListViewItem In objListview.SelectedItems
                oListViewItem.Selected = False
            Next
        Else
            If bSearched = False Then
                'Bei ersten Mal in erster Zeilen beginnen
                iSearchStart = 0
            Else
                iSearchStart = iLastFoundRowIndex + 1
            End If
        End If



        bSearched = True
        If combSearchColumn.SelectedIndex <> combSearchColumn.Items.Count - 1 Then
            'Suche über eine Spalte

            For i = iSearchStart To objListview.Items.Count - 1
                iLastCheckedRowIndex = i
                Try
                    If ContainsPlus(objListview.Items(i).SubItems(combSearchColumn.SelectedIndex).Text, txtSearchText.Text, Not chkNonCaseSensetive.Checked, chkOnlyWholeWord.Checked, chkSearchTextIsRegEx.Checked) = True Then
                        bTextFound = True
                        iLastFoundRowIndex = i
                        objListview.Select()
                        objListview.Items(i).Selected = True
                        If objListview.MultiSelect = False Then GoTo EndSearch
                    End If
                Catch ex As Exception
                    If chkSearchTextIsRegEx.Checked = True Then MessageBox.Show("Fehler beim Auswerten des Regulären Ausdrucks!" & Environment.NewLine & Environment.NewLine & "Fehler:" & Environment.NewLine & ex.Message, "Fehler bei Regulären-Ausdruck", MessageBoxButtons.OK, MessageBoxIcon.Error)
                    GoTo EndSearchWithoutMsgBoxTextNotFound
                End Try

            Next
        Else
            'Suche über alle Spalten

            For i = iSearchStart To objListview.Items.Count - 1
                iLastCheckedRowIndex = i

                For y = 0 To objListview.Columns.Count - 1
                    'Versteckte Spalten überspringen Option entsprechend eingestellt
                    If bolIngnoreColumnsWithZeroWidth = True AndAlso objListview.Columns(y).Width = 0 Then Continue For

                    Try
                        If ContainsPlus(objListview.Items(i).SubItems(y).Text, txtSearchText.Text, Not chkNonCaseSensetive.Checked, chkOnlyWholeWord.Checked, chkSearchTextIsRegEx.Checked) = True Then
                            bTextFound = True
                            iLastFoundRowIndex = i
                            objListview.Select()
                            objListview.Items(i).Selected = True
                            If objListview.MultiSelect = False Then GoTo EndSearch
                            GoTo NextRow 'Wenn eine Zeile Markiert wurde, müssen folgende Spalten nicht mehr geprüft werden
                        End If
                    Catch ex As Exception
                        If chkSearchTextIsRegEx.Checked = True Then MessageBox.Show("Fehler beim Auswerten des Regulären Ausdrucks!" & Environment.NewLine & Environment.NewLine & "Fehler:" & Environment.NewLine & ex.Message, "Fehler bei Regulären-Ausdruck", MessageBoxButtons.OK, MessageBoxIcon.Error)
                        GoTo EndSearchWithoutMsgBoxTextNotFound
                    End Try
                Next
NextRow:
            Next


        End If


EndSearch:

        'Wenn Text nicht gefunde wurde, dann Meldung
        If bTextFound = False Then
            MessageBox.Show("Der Text konnte mit den angegebenen Suchkriterien nicht in der Liste gefunden werden!", "Suche", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Exit Sub
        End If

EndSearchWithoutMsgBoxTextNotFound:

        'Bei Multi-Select ListView Dialog schließen, bei Single-Select Liste scrollen
        If objListview.MultiSelect = True Then
            Me.DialogResult = System.Windows.Forms.DialogResult.OK
            Me.Close()
        Else
            If objListview.SelectedItems.Count <> 0 Then objListview.EnsureVisible(objListview.SelectedItems(0).Index)
        End If

        'Hauptformular in den Vordergrund bringen, damit Selektion sichtbar wird
        objMainForm.BringToFront()

    End Sub

    Private Sub Cancel_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Cancel_Button.Click
        Me.DialogResult = System.Windows.Forms.DialogResult.Cancel
        Me.Close()
    End Sub
    Private Sub frmFindInListView_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        txtSearchText.Select()
        If objListview.MultiSelect = True Then OK_Button.Text = "OK" Else OK_Button.Text = "Weitersuchen"
    End Sub

    Public Overloads Sub Show(ByVal oListview As ListView, ByVal oMainForm As Form, Optional ByVal bIngnoreColumnsWithZeroWidth As Boolean = False)
        'Alle Spalten des Listviews in Auswahl aufnehmen
        Dim i As Integer

        objListview = oListview
        objMainForm = oMainForm
        bolIngnoreColumnsWithZeroWidth = bIngnoreColumnsWithZeroWidth

        For i = 0 To objListview.Columns.Count - 1
            If bIngnoreColumnsWithZeroWidth = True AndAlso objListview.Columns(i).Width = 0 Then Continue For
            combSearchColumn.Items.Add(objListview.Columns(i).Text)
        Next
        combSearchColumn.Items.Add("-- ALLE SPALTEN --")
        combSearchColumn.SelectedIndex = combSearchColumn.Items.Count - 1


        MyBase.Show(objListview)
    End Sub
    Public Overloads Sub ShowDialog(ByVal oListview As ListView, ByVal oMainForm As Form, Optional ByVal bIngnoreColumnsWithZeroWidth As Boolean = False)
        'ShowDialog muss verwendet werden, damit Fokus wieder richtig gesetzt wird, wenn Dialog beendet wird
        Show(oListview, oMainForm)
    End Sub

    ''' Diese Funktion prüft, ob eine Bestimmte Zeichenfolge oder ein Wort in einem Text vorkommt
    ''' </summary>
    ''' <param name="WholeText">Kompletter Text in dem geprüft werden soll</param>
    ''' <param name="ContainText">Zu suchender Text</param>
    ''' <param name="bIgnoreCase">Wenn True, wird Gross-/Kleinschreibung ignoriert</param>
    ''' <param name="bOnlyWholeWords">Wenn True, muss 'ContainText' als komplettes Wort vorhanden sein und nicht nur in einer Zeichenkette vorkommen.</param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Private Function ContainsPlus(ByVal WholeText As String, ByVal ContainText As String, Optional ByVal bIgnoreCase As Boolean = True, Optional ByVal bOnlyWholeWords As Boolean = False, Optional ByVal bContainTextIsRegularExpression As Boolean = False) As String
        Dim tmpContainText As String = ""

        'Wenn ContainText keine Regulären Ausdrücke enthält, dann ContainText in ASCI-Codes für REGEX umsetzen, damit z.B. ] nicht als Regulärer-Ausdruck interpretiert wird, sonstern als Text 
        If bContainTextIsRegularExpression = False Then
            Dim byteArray() As Byte
            Dim hexNumbers As System.Text.StringBuilder = New System.Text.StringBuilder

            byteArray = System.Text.ASCIIEncoding.ASCII.GetBytes(ContainText)

            For i As Integer = 0 To byteArray.Length - 1
                hexNumbers.Append("\x" & byteArray(i).ToString("x"))
            Next
            tmpContainText = hexNumbers.ToString

        Else
            tmpContainText = ContainText
        End If

        'Patterns für ganzens Worte setzen (Wenn nur auf komplette Wörter geprüft werden soll)
        If bOnlyWholeWords = True Then tmpContainText = tmpContainText & "\b"


        If bIgnoreCase = True Then
            Return Regex.IsMatch(WholeText, tmpContainText, RegexOptions.IgnoreCase)
        Else
            Return Regex.IsMatch(WholeText, tmpContainText)
        End If

    End Function

    Private Sub txtSearchText_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtSearchText.TextChanged
        bTextFound = False 'Zurück setzen das Text gefunden wurde
    End Sub
    Private Sub combSearchColumn_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles combSearchColumn.SelectedIndexChanged
        bTextFound = False 'Zurück setzen das Text gefunden wurde
    End Sub
    Private Sub chkNonCaseSensetive_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkNonCaseSensetive.CheckedChanged
        bTextFound = False 'Zurück setzen das Text gefunden wurde
    End Sub
    Private Sub chkOnlyWholeWord_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkOnlyWholeWord.CheckedChanged
        bTextFound = False 'Zurück setzen das Text gefunden wurde
    End Sub
End Class
